Option Explicit On
Option Strict On
Imports System.Runtime.InteropServices
Imports System.Diagnostics

Public Class Class1
    Private Const FileName As String = "C:\sample.mdb"
    Private Const SampleDataCount As Integer = 100000 '10

    Public Shared Sub Main()
        '--- O:Tvf[^x[X̍쐬 ---
        Dim DE As dao.DBEngine = New dao.DBEngineClass()
        Dim WS As dao.Workspace = DE.CreateWorkspace("#Default Workspace#", "Admin", String.Empty)
        Dim DB As dao.Database = WS.CreateDatabase(FileName, dao.LanguageConstants.dbLangJapanese)
        WS.BeginTrans()
        DB.Execute("CREATE TABLE TEST (ID LONG, NAME TEXT(50))")
        DE.Idle(dao.IdleEnum.dbRefreshCache)

        '--- v:ݏJn ---
        Dim sw As Stopwatch = Stopwatch.StartNew()

        'e[u^CṽR[hZbgJ
        Dim RS As dao.Recordset = DB.OpenRecordset(
                "TEST",
                dao.RecordsetTypeEnum.dbOpenTable, _
                dao.RecordsetOptionEnum.dbDenyWrite Or dao.RecordsetOptionEnum.dbInconsistent, _
                dao.LockTypeEnum.dbPessimistic)

        'FieldϐLbV
        Dim fs As dao.Fields = RS.Fields
        Dim fID As dao.Field = fs("ID")
        Dim fName As dao.Field = fs("NAME")

        '_~[f[^쐬
        For I As Integer = 1 To SampleDataCount
            RS.AddNew()
            fID.Value = I
            fName.Value = GetRandomText()
            RS.Update()
        Next

        Marshal.ReleaseComObject(fID)
        Marshal.ReleaseComObject(fName)
        Marshal.ReleaseComObject(fs)
        RS.Close()
        Marshal.ReleaseComObject(RS)
        WS.CommitTrans(dao.CommitTransOptionsEnum.dbForceOSFlush)


        '--- v ---
        sw.Stop()

        System.Console.WriteLine("{0:0.0000}b", sw.ElapsedTicks / Stopwatch.Frequency)

        DB.Close()
        Marshal.ReleaseComObject(DB)
        WS.Close()
        Marshal.ReleaseComObject(WS)
        Marshal.ReleaseComObject(DE)
    End Sub

    Private Shared Function GetRandomText() As String
        Static R As New System.Random()
        Return New String("@"c, R.Next(1, 50))
    End Function

End Class
